#include <iostream>
#include <cmath>
#include <fstream>

template<typename T>
T f(const T &x) { return x+pow(x,4); }

template<typename T>
T dfdx(const T &x) { return 1+4*pow(x,3); }

template<typename T>
T ddfdxx(const T &x) { return 12*pow(x,2); }

template<typename T>
void solve(T& x, const T& eps) {
  std::ofstream fout("data");
  T g=dfdx(x), y=f(x),y_prev;
  while (fabs(g)>eps) {
    fout << x << " " << f(x) << std::endl;
    std::cout << ".";
    y_prev=y;
    double alpha=2.;
    while (y_prev<=y&&alpha>eps) {
      std::cout << "-";
      T x_trial=x; alpha/=2;
      x_trial-=alpha*g; y=f(x_trial);
    }
    x-=alpha*g; g=dfdx(x);
  }
  fout << x << " " << f(x) << std::endl;
  std::cout << std::endl;
  fout.close();
}

int main(int, char *v[]) {
  double x=std::stof(v[1]);
  solve(x,1e-7);
  std::cout << "x=" << x << std::endl
            << "f(x)=" << f(x) << std::endl
            << "dfdx(x)=" << dfdx(x) << std::endl
            << "ddfdxx(x)=" << ddfdxx(x) << std::endl;
  return 0;
}
