#include <iostream>
#include <cmath>
#include <fstream>

template<typename T>
T f(const T &x) { return 1+4*pow(x,3); }

template<typename T>
T dfdx(const T &x) { return 12*pow(x,2); }

template<typename T>
T ddfdxx(const T &x) { return 24*x; }

template<typename T>
void solve(T& x, const T& eps) {
  std::ofstream fout("data");
  while (fabs(f(x))>eps) {
    fout << x << " " << f(x) << std::endl;
    std::cout << ".";
    x-=f(x)/dfdx(x);
  }
  std::cout << std::endl;
  fout << x << " " << f(x) << std::endl;
  fout.close();
}

int main(int, char *v[]) {
  double x=std::stof(v[1]);
  std::cout << "|g'("<< x << ")|=" 
	    << fabs(f(x)*ddfdxx(x)/pow(dfdx(x),2)) << std::endl;
  solve(x,1e-12);
  std::cout << "x=" << x << std::endl
            << "f(x)=" << f(x) << std::endl
            << "dfdx(x)=" << dfdx(x) << std::endl;
  return 0;
}

